//
// Created by Laura Majer on 08/04/2020.
//

#ifndef VRPEVALOP_H_
#define VRPEVALOP_H_

#include "../../ECF/ECF.h"
#include <cmath>
#include <iostream>
#include <string>
#include <fstream>
#include <vector>


class VRPEvalOp : public EvaluateOp
{
private:
    int dimension;
    int capacity;
    int fleetSize;
    std::vector< std::vector<int> > weights;
    std::vector< std::vector<double> > coordinates;
    std::vector<int> demand;
public:
    void registerParameters(StateP);
    bool initialize(StateP);
    FitnessP evaluate(IndividualP individual);
};
typedef boost::shared_ptr<VRPEvalOp> VRPEvalOpP;

#endif /* VRPEVALOP_H_ */