#ifndef ADAPT_PERMUTATIONCRSCYCLIC_H
#define ADAPT_PERMUTATIONCRSCYCLIC_H

#include "examples/VRP/AdaptedPermutation.h"


namespace AdaptedPermutation
{

/**
 * \ingroup genotypes permutation
 * \brief Permutation genotype: Cyclic crossover operator (see e.g. http://www.rubicite.com/Tutorials/GeneticAlgorithms/CrossoverOperators/CycleCrossoverOperator.aspx)
 */
class AdaptedPermutationCrsCyclic : public CrossoverOp
{
public:
	bool mate(GenotypeP gen1, GenotypeP gen2, GenotypeP child);
	bool initialize(StateP);
	void registerParameters(StateP);
};
typedef boost::shared_ptr<AdaptedPermutationCrsCyclic> AdaptedPermutationCrsCyclicP;
}
#endif //ADAPT_PERMUTATIONCRSCYCLIC_H
