#ifndef ADAPT_CRSOX2_H
#define ADAPT_CRSOX2_H

#include "examples/VRP/AdaptedPermutation.h"


namespace AdaptedPermutation
{

/**
 * \ingroup genotypes AdaptedPermutation
 * \brief AdaptedPermutation genotype: Order crossover operator variant where algorithm starts from the beginning when copying the values from second parent (adapted from HeuristicLab)
 */
class AdaptedPermutationCrsOX2 : public CrossoverOp
{
public:
	bool mate(GenotypeP gen1, GenotypeP gen2, GenotypeP child);
	bool initialize(StateP);
	void registerParameters(StateP);
};
typedef boost::shared_ptr<AdaptedPermutationCrsOX2> AdaptedPermutationCrsOX2P;
}
#endif //ADAPT_CRSOX2_H
