#ifndef ADAPT_CRSPBX_H
#define ADAPT_CRSPBX_H

#include <ECF/Crossover.h>
#include "examples/VRP/AdaptedPermutation.h"


namespace AdaptedPermutation
{

/**
 * \ingroup genotypes AdaptedPermutation
 * \brief AdaptedPermutation genotype: PBX crossover operator (see e.g. http://dx.doi.org/10.1016/j.amc.2007.10.013)
 */
class AdaptedPermutationCrsPBX : public CrossoverOp
{
public:
	bool mate(GenotypeP gen1, GenotypeP gen2, GenotypeP child);
	bool initialize(StateP);
	void registerParameters(StateP);
};
typedef boost::shared_ptr<AdaptedPermutationCrsPBX> AdaptedPermutationCrsPBXP;
}
#endif //ADAPT_CRSPBX_H
