#ifndef ADAPT_CRSPMX_H
#define ADAPT_CRSPMX_H

#include "examples/VRP/AdaptedPermutation.h"


namespace AdaptedPermutation
{

/**
 * \ingroup genotypes AdaptedPermutation
 * \brief AdaptedPermutation genotype: PMX crossover operator (see e.g. http://dx.doi.org/10.1016/j.amc.2007.10.013)
 */
class AdaptedPermutationCrsPMX : public CrossoverOp
{
public:

	bool mate(GenotypeP gen1, GenotypeP gen2, GenotypeP child);
	bool initialize(StateP);
	void registerParameters(StateP);
};
typedef boost::shared_ptr<AdaptedPermutationCrsPMX> AdaptedPermutationCrsPMXP;
}
#endif //ADAPT_CRSPMX_H
