#ifndef ADAPT_CRSSPX_H
#define ADAPT_CRSSPX_H

#include "examples/VRP/AdaptedPermutation.h"

namespace AdaptedPermutation
{

/**
 * \ingroup genotypes AdaptedPermutation
 * \brief AdaptedPermutation genotype: SPX crossover operator (see e.g. itc.ktu.lt/itc342/Misev342.pdf)
 */
class AdaptedPermutationCrsSPX : public CrossoverOp
{
public:
	bool mate(GenotypeP gen1, GenotypeP gen2, GenotypeP child);
	bool initialize(StateP);
	void registerParameters(StateP);
};
typedef boost::shared_ptr<AdaptedPermutationCrsSPX> AdaptedPermutationCrsSPXP;
}
#endif //ADAPT_CRSSPX_H
