#ifndef ADAPT_CRSUPMX_H
#define ADAPT_CRSUPMX_H

#include <ECF/Crossover.h>
#include "examples/VRP/AdaptedPermutation.h"

namespace AdaptedPermutation
{

/**
 * \ingroup genotypes AdaptedPermutation
 * \brief AdaptedPermutation genotype: UMPX crossover operator (see e.g. itc.ktu.lt/itc342/Misev342.pdf)
 */
class AdaptedPermutationCrsUPMX : public CrossoverOp
{
public:
	bool mate(GenotypeP gen1, GenotypeP gen2, GenotypeP child);
	bool initialize(StateP);
	void registerParameters(StateP);
};
typedef boost::shared_ptr<AdaptedPermutationCrsUPMX> AdaptedPermutationCrsUPMXP;
}
#endif //ADAPT_CRSUPMX_H
