#ifndef NEW_PERMUTATIONCRSCYCLIC_H
#define NEW_PERMUTATIONCRSCYCLIC_H

#include "examples/VRP/NewPermutation.h"


namespace NewPermutation
{

/**
 * \ingroup genotypes permutation
 * \brief Permutation genotype: Cyclic crossover operator (see e.g. http://www.rubicite.com/Tutorials/GeneticAlgorithms/CrossoverOperators/CycleCrossoverOperator.aspx)
 */
class NewPermutationCrsCyclic : public CrossoverOp
{
public:
	bool mate(GenotypeP gen1, GenotypeP gen2, GenotypeP child);
	bool initialize(StateP);
	void registerParameters(StateP);
};
typedef boost::shared_ptr<NewPermutationCrsCyclic> NewPermutationCrsCyclicP;
}
#endif //NEW_PERMUTATIONCRSCYCLIC_H
