#include "ECF/ECF_base.h"
#include "examples/VRP/NewPermutation.h"
#include "NewPermutationCrsCyclic2.h"
#include <map>


namespace NewPermutation
{

void NewPermutationCrsCyclic2::registerParameters(StateP state)
{
	myGenotype_->registerParameter(state, "crx.cyclic2", (voidP) new double(0), ECF::DOUBLE);
}


bool NewPermutationCrsCyclic2::initialize(StateP state)
{
	voidP sptr = myGenotype_->getParameterValue(state, "crx.cyclic2");
	probability_ = *((double*)sptr.get());
	return true;
}


bool NewPermutationCrsCyclic2::mate(GenotypeP gen1, GenotypeP gen2, GenotypeP child)
{
	NewPermutation* p1 = (NewPermutation*) (gen1.get());
	NewPermutation* p2 = (NewPermutation*) (gen2.get());
	NewPermutation* ch = (NewPermutation*) (child.get());


	std::map<int, int>  index;
	int j, num;

	j = state_->getRandomizer()->getRandomInteger(p1->getSize());

	while (!index[j]) { //da li je ovo OK?
		ch->variables[j] = p1->variables[j];
		num = p2->variables[j];
		index[j] = 1;

		j = 0;
		while ((j < (int) p1->getSize()) && (p1->variables[j] != num)) {
		  j++;
		}
	}

	  for (int i = 0; i < (int) p1->getSize(); i++) {
		if (!index[i]) {
			ch->variables[i] = p2->variables[i];
		}
	  }

	return true;
}

}
