#include "../ECF_base.h"
#include "AdaptedPermutation.h"


namespace AdaptedPermutation
{

void AdaptedPermutationMutInv::registerParameters(StateP state)
{
	myGenotype_->registerParameter(state, "mut.inv", (voidP) new double(0), ECF::DOUBLE);
}


bool AdaptedPermutationMutInv::initialize(StateP state)
{
	voidP sptr = myGenotype_->getParameterValue(state, "mut.inv");
	probability_ = *((double*)sptr.get());
	return true;
}


bool AdaptedPermutationMutInv::mutate(GenotypeP gene)
{
	AdaptedPermutation* perm = (AdaptedPermutation*) (gene.get());

	//najvi�e mo�emo uzeti predzandnji element kao po�etak podniza
	int ind1 = state_->getRandomizer()->getRandomInteger(perm->getSize() - 1);
	int ind2 = state_->getRandomizer()->getRandomInteger(ind1, perm->getSize() - 1);
	int temp = perm->variables[ind2];
	int distance = ind2 -ind1 + 1;

	for(int i = 0; i < distance / 2; i++) {
		temp = perm->variables[ind1 + i];
		perm->variables[ind1 + i] = perm->variables[ind2 - i];
		perm->variables[ind2 - i] = temp;
	}

	return true;
}

}
