#ifndef ADAPT_PERMUTATIONMUTINV_H_
#define ADAPT_PERMUTATIONMUTINV_H_


namespace AdaptedPermutation
{

/**
 * \ingroup genotypes permutation
 * \brief AdaptedPermutation genotype: inversion mutation operator (see e.g. http://dx.doi.org/10.1016/j.amc.2007.10.013)
 */
class AdaptedPermutationMutInv: public MutationOp {
public:
	bool mutate(GenotypeP gene);
	bool initialize(StateP);
	void registerParameters(StateP);
};
typedef boost::shared_ptr<AdaptedPermutationMutInv> AdaptedPermutationMutInvP;
}
#endif /* PERMUTATIONMUTINV_H_ */
