#include "ECF/ECF_base.h"
#include "examples/VRP/AdaptedPermutation.h"
#include "AdaptedPermutationMutToggle.h"


namespace AdaptedPermutation
{

void AdaptedPermutationMutToggle::registerParameters(StateP state)
{
	myGenotype_->registerParameter(state, "mut.toggle", (voidP) new double(0), ECF::DOUBLE);
}


bool AdaptedPermutationMutToggle::initialize(StateP state)
{
	voidP sptr = myGenotype_->getParameterValue(state, "mut.toggle");
	probability_ = *((double*)sptr.get());
	return true;
}


bool AdaptedPermutationMutToggle::mutate(GenotypeP gene)
{
	AdaptedPermutation* perm = (AdaptedPermutation*) (gene.get());


    //mijenjaju se 2 lokacije nevezano o tome iz kojeg su vozila
	bool found1 = false, found2 = false;
	int ind1,ind2;
	while(!found1) {
        ind1 = state_->getRandomizer()->getRandomInteger(perm->getSize());
        if (perm->variables[ind1] < perm->getProblemSize()) {
            found1 = true;
        }
    }
    while(!found2) {
        ind2 = state_->getRandomizer()->getRandomInteger(perm->getSize());
        int diff = ind2 - ind1;
        if (perm->variables[ind2] < perm->getProblemSize() && (diff < -1 || diff > 1)) {
            found2 = true;
        }
    }

	int temp = perm->variables[ind1];
	perm->variables[ind1] = perm->variables[ind2];
	perm->variables[ind2] = temp;

	return true;
}

}
