#include "ECF/ECF_base.h"
#include "examples/VRP/NewPermutation.h"
#include "NewPermutationMutIns.h"


namespace NewPermutation
{

void NewPermutationMutIns::registerParameters(StateP state)
{
	myGenotype_->registerParameter(state, "mut.ins", (voidP) new double(0), ECF::DOUBLE);
}


bool NewPermutationMutIns::initialize(StateP state)
{
	voidP sptr = myGenotype_->getParameterValue(state, "mut.ins");
	probability_ = *((double*)sptr.get());
	return true;
}


bool NewPermutationMutIns::mutate(GenotypeP gene)
{
	NewPermutation* perm = (NewPermutation*) (gene.get());

	//navjei indeks za prvi element insert mutacije
	//mora biti maksimalno predzadnji u nizu
	int ind1 = state_->getRandomizer()->getRandomInteger(perm->getSize() - 1);
	int ind2 = state_->getRandomizer()->getRandomInteger(ind1, perm->getSize() - 1);
	int temp = perm->variables[ind2];

	//posmicemo udesno
	for(int i = ind2; i > ind1; i--) {
		//temp=perm->variables[i];
		perm->variables[i] = perm->variables[i - 1];
	}
	//za slucaj da su indeksi razliciti stavljamo element koji smo prebrisali
	//tj zadnji element podniza iza prvog elementa
	//inace se for petlja uopce nije izvrsila pa bismo 2x isti element imali
	if(ind1 != ind2)
		perm->variables[ind1 + 1] = temp;

	return true;
}

}
